package com.vanheusden.pfa;

import java.io.*;
import java.sql.*;
import java.util.*;

public abstract class Book {
	protected String name, table;
	protected Connection con;
	protected Statement get;
	protected int min_hits;

	public Book(final String url) throws Exception {
		try {
			Statics.log("Initializing book " + url);

			min_hits = 12;

			Class.forName("com.mysql.jdbc.Driver");

			String [] parts = url.split(",");

			String connectUrl = null, user = null, password = null;
			for(String cur : parts) {
				int is = cur.indexOf('=');
				if (is == -1)
					throw new Exception("\"" + cur + "\" unexpected format");

				String [] pcur = new String[2];
				pcur[0] = cur.substring(0, is);
				pcur[1] = cur.substring(is + 1);

				if (pcur[0].equals("url"))
					connectUrl = pcur[1];
				else if (pcur[0].equals("user"))
					user = pcur[1];
				else if (pcur[0].equals("password"))
					password = pcur[1];
				else if (pcur[0].equals("name"))
					name = pcur[1];
				else if (pcur[0].equals("table"))
					table = pcur[1];
				else if (pcur[0].equals("min_hits"))
					min_hits = Integer.valueOf(pcur[1]);
				else
					throw new Exception("\"" + cur + "\" not understood");
			}

			con = DriverManager.getConnection(connectUrl, user, password);
			get = con.createStatement();
		}
		catch(Exception e) {
			throw new Exception(url + ": " + e);
		}
	}

	public String getName() {
		return name;
	}

	abstract public MoveResult search(final Scene s, final Move lastMove, final PlayerColor who) throws Exception;
}
