package com.vanheusden.pfa;

import java.io.*;

class BrainPonder implements Runnable {
	Thread t;
	IO io;
	Brain brain;
	int moveNr;
	Scene scene;
	int endDepth;
	PlayerColor myColor;
	MoveRepetition history;
	long maxDuration;
	int maxExtension;
	Move lastMove;
	MoveResult sr = null;

	public void run() {
		try {
			sr = brain.calculateMove(moveNr, scene, 0/* FIXME endDepth*/, myColor, history, maxDuration, maxExtension, lastMove, true);

			io.progressCallback("Ponder result: " + sr);
		}
		catch(Exception e) {
			Statics.logException("BrainPonder", e);

			try {
				io.progressCallback("Ponder thread exception: " + e);
			}
			catch(Exception e2) {
				Statics.log("Reporting an exception gave an exception: " + e2);
			}
		}
	}

	public BrainPonder(final IO io, final Brain brain) {
		this.io = io;
		this.brain = brain;
	}

	public void startPonder(final int moveNr, final Scene scene, final int endDepth, final PlayerColor myColor, final MoveRepetition history, final long maxDuration, final int maxExtension, final Move lastMove) throws IOException {
		this.moveNr = moveNr;
		this.scene = scene;
		this.endDepth = endDepth;
		this.myColor = myColor;
		this.history = history;
		this.maxDuration = maxDuration;
		this.maxExtension = maxExtension;
		this.lastMove = lastMove;

		t = new Thread(this);
		t.start();

		io.progressCallback("Ponder thread started");
	}

	public MoveResult stopPonder() throws IOException {
		if (t == null)
			return null;

		long start = System.currentTimeMillis();

		io.progressCallback("Stopping ponder thread");

		brain.toDetected.set(true);

		try {
			t.join();
		}
		catch(Exception e) {
			io.progressCallback("While waiting for ponder thread to stop: " + e);
		}

		t = null;

		Statics.log("Ponder thread stop took " + (System.currentTimeMillis() - start) / 1000.0 + " seconds");

		return sr;
	}
}
