package com.vanheusden.pfa;

import java.io.*;
import java.util.*;

class IO_logonly extends IO {
	void loop() {
		Statics.log("FAIL");
		System.exit(1);
	}

	public IO_logonly() {
		super(-1, -1, false, -1, null, false, false, null);
	}

	public void progressCallbackXboardShowThinking(int id, int score, long durationCentiSeconds, long nodesVisited, String details) throws IOException {
		String what = "" + id + " " + score + " " + durationCentiSeconds + " " + nodesVisited + " " + details;

		Statics.log(what);
	}

	public void progressCallback(String what) throws IOException {
		Statics.log(what);
	}

	public void progressCallbackDebug(String what) throws IOException {
		Statics.log(what);
	}

	public void progressBenchmark(int depth, int nThreads, int numberOfThreadSlots, long nNodesVisited, double took, Board b, MoveResult m, long nExtensions, long nCutOffs, long nTPT) throws IOException {
		String what = "" + depth + " " + nThreads + " " + numberOfThreadSlots + " " + nNodesVisited + " " + took + " " + (nNodesVisited / took) + " " + nExtensions + " " + nCutOffs + " " + nTPT + " " + m.toString();

		Statics.log(what);
	}

	public void progressCallbackNPS(int nps) throws IOException {
		Statics.log("Nodes/s " + nps);
	}

	public void progressCallbackTimeSearch(int ms) throws IOException {
		Statics.log("Time searched: " + ms + "ms");
	}

	public void progressCallbackBest(Move move, int score) throws IOException {
		Statics.log("Best move: " + move + " (" + score + ")");
	}

	public void progressCallbackNNodes(long nNodes) throws IOException {
		Statics.log("Total nodes searched: " + nNodes);
	}

	public void progressCallbackDepthReached(int depth) throws IOException {
		Statics.log("Depth reached: " + depth);
	}

	public void progressCallbackCurrMove(Move move) throws IOException {
		Statics.log("Current move: " + move);
	}
}
