package com.vanheusden.pfa;

import java.util.*;

class MoveRepetition {
	protected final Deque<Long> white;
	protected final Deque<Long> black;

	MoveRepetition() {
		white = new ArrayDeque<Long>();
		black = new ArrayDeque<Long>();
	}

	MoveRepetition(final MoveRepetition in) {
		white = new ArrayDeque<Long>(in.getAllWhite());
		black = new ArrayDeque<Long>(in.getAllBlack());
	}

	Deque<Long> getAllWhite() {
		return white;
	}

	Deque<Long> getAllBlack() {
		return black;
	}

	void push(final PlayerColor color, long hash) {
		if (color == PlayerColor.WHITE)
			white.push(hash);
		else
			black.push(hash);
	}

	void pop(final PlayerColor color) {
		if (color == PlayerColor.WHITE)
			white.pop();
		else
			black.pop();
	}

	boolean contains(final PlayerColor color, long hash) {
		if (color == PlayerColor.WHITE)
			return white.contains(hash);

		return black.contains(hash);
	}	
}
