package com.vanheusden.pfa;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.PackageManager.NameNotFoundException;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;

public class PosForAndroidActivity extends Activity {
	private static final int MENU_QUIT = 0;

	public boolean onCreateOptionsMenu(Menu menu) {
		menu.add(0, MENU_QUIT, 0, "quit");
		return true;
	}

	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
			case MENU_QUIT:
				stopService(new Intent(PosForAndroidActivity.this, PosService.class));
				System.exit(0);
				return true;
		}
		return false;
	}

	private DataUpdateReceiver dataUpdateReceiver;

	private class DataUpdateReceiver extends BroadcastReceiver {
		@Override
		public void onReceive(Context context, Intent intent) {
			TextView outputWindow = (TextView)findViewById(R.id.OutputWindow);
			outputWindow.append("\n" + intent.getExtras().getString("msg"));
		}
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.main);

		if (dataUpdateReceiver == null)
			dataUpdateReceiver = new DataUpdateReceiver();

		registerReceiver(dataUpdateReceiver, new IntentFilter(PosService.msgFilter));

		TextView outputWindow = (TextView)findViewById(R.id.OutputWindow);

		try {
			String appVersion = "?";

			try {
				appVersion = this.getPackageManager().getPackageInfo(this.getPackageName(), 0).versionName;
			}
			catch(NameNotFoundException e) {
			}

			TextView version = (TextView)findViewById(R.id.version);
			version.setText(Version.getName() + " engine v" + Version.getVersion() + ", Android version: " + appVersion);

			startService(new Intent(PosForAndroidActivity.this, PosService.class));

			int width = getWindowManager().getDefaultDisplay().getWidth();
			outputWindow.setWidth(width);
			outputWindow.setText("Engine thread started");
		}
		catch(Exception e) {
			outputWindow.setText("Initialization failed: " + e);
		}
	}
}
